﻿using System;
using System.Runtime.InteropServices;
using System.IO;
using System.Collections.Generic;

namespace CSV2HST
{
    public class Globals
    {
        public static int Main(string[] argv)
        {
            int argc = argv.Length; //Use this later for passing file names in
            long fsLength = -1; //Use to cache file length (improves performance)
            long fsPosition = 0; //Use to cache current file position (improves performance)
            int recordSize = 0; //Size of current struct to be read

            //Open the file and cache the length
            FileStream fs = new FileStream(@"d:\temp\AUDNZD1.hst", FileMode.Open, FileAccess.Read, FileShare.Read);
            fsLength = fs.Length;
            fsPosition = 0;

            //Create a header variable and get the size
            HST_HeaderRecord header;
            recordSize = Marshal.SizeOf(typeof(HST_HeaderRecord));

            //ensure that the end of the next record is within the file length ie testing for End of file
            //Read the header from the file into our HST_HeaderRecord structure.
            fsPosition += recordSize;
            if (fsPosition <= fsLength)
                header = MarshalHelper.Read<HST_HeaderRecord>(fs);

            //Create a RateInfo variable and get size
            HST_RateInfoRecord rateInfo;
            recordSize = Marshal.SizeOf(typeof(HST_RateInfoRecord));
            int rateInfoRecordsCount = (int)((fsLength - fsPosition)/recordSize);
            SortedList<DateTime, HST_RateInfoRecord> rateInfoCollection = new SortedList<DateTime, HST_RateInfoRecord>(rateInfoRecordsCount);

            //ensure that the end of the next record is within the file length ie testing for End of file
            //Read the RateInfo from the file into our HST_DataRecord structure.
            fsPosition += recordSize;
            while (fsPosition <= fsLength)
            {
                rateInfo = MarshalHelper.Read<HST_RateInfoRecord>(fs);
                fsPosition += recordSize;
                try
                {
                    rateInfoCollection.Add(rateInfo.TimeStamp, rateInfo);
                }
                catch (System.ArgumentException)
                {
                    //Duplicate found
                }
            }

            //Cleaning up
            fs.Close();
            fs = null;
            return 0;
        }
    }
}